source("time.r")
 
test.name <- "tst-cum.double"

n <- 400
a <- c(1:n,n:1) + 0.1

f <- test.cmp (function () {for (i in 1:1000000) b <- cumsum(a); b})
sys.time(b<-f()); print(b)

f <- test.cmp (function () {for (i in 1:100000) b <- cumprod(a); b})
sys.time(b<-f()); print(b)

f <- test.cmp (function () {for (i in 1:1000000) b <- cummax(a); b})
sys.time(b<-f()); print(b)

f <- test.cmp (function () {for (i in 1:1000000) b <- cummin(a); b})
sys.time(b<-f()); print(b)

a[300] <- 0/0
a[500] <- NA

f <- test.cmp (function () {for (i in 1:500000) b <- cumsum(a); b})
sys.time(b<-f()); print(b)
 
test.name <- "tst-cum.int"

n <- 900
a <- c(1:n,n:1)

f <- test.cmp (function () {for (i in 1:1000000) b <- cumsum(a); b})
sys.time(b<-f()); print(b)

f <- test.cmp (function () {for (i in 1:1000000) b <- cummax(a); b})
sys.time(b<-f()); print(b)

f <- test.cmp (function () {for (i in 1:1000000) b <- cummin(a); b})
sys.time(b<-f()); print(b)

a[300] <- NA

f <- test.cmp (function () {for (i in 1:1000000) b <- cumsum(a); b})
sys.time(b<-f()); print(b)
 
test.name <- "tst-cum.complex"

n <- 100
a <- c(1:n,n:1) + 0.1i

f <- test.cmp (function () {for (i in 1:1000000) b <- cumsum(a); b})
sys.time(b<-f()); print(b)

f <- test.cmp (function () {for (i in 1:1000000) b <- cumprod(a); b})
sys.time(b<-f()); print(b)
