source("time.r")
 
a <- seq(1,3,length=1000)
a[900] <- NA
a[901] <- 0/0
a[950] <- NA
a[1000] <- NA
ai <- as.integer(100*a)
as <- as.character(ai)

b <- a
b[20] <- NA

n <- 1000000

f <- test.cmp (function (x,n) { for (i in 1:n) r <- is.na(x); r})
g <- test.cmp (function (x,n) { for (i in 1:n) r <- is.nan(x); r})
h <- test.cmp (function (x,n) { for (i in 1:n) r <- is.finite(x); r})

test.name <- "tst-isna.integer"

sys.time(r <- f(ai,n)); print(sum(r))

test.name <- "tst-isna.character"

sys.time(r <- f(as,n)); print(sum(r))

test.name <- "tst-isna.real"

sys.time(r <- f(a,n)); print(sum(r))
sys.time(r <- g(a,n)); print(sum(r))
sys.time(r <- h(a,n)); print(sum(r))

test.name <- "tst-isna.anyNA"

if (!exists("anyNA")) anyNA <- function (x) any(is.na(x))

f <- test.cmp (function (x,n) { for (i in 1:n) r <- any(is.na(x)); r})
g <- test.cmp (function (x,n) { for (i in 1:n) r <- anyNA(x); r})

sys.time(r <- f(a,n)); print(r)
sys.time(r <- g(a,n)); print(r)

sys.time(r <- f(b,n)); print(r)
sys.time(r <- g(b,n)); print(r)
