source("time.r")
 
a <- 9
attributes(a) <- list (dd=1.4, cc=1.3, bb=1.2, aa=1.1)

test.name <- "tst-attr.get"

n <- 2000000

f <- test.cmp (function () {for (i in 1:n) r <- attr(a,"bb"); r })

sys.time(r<-f())
print(r)

f <- test.cmp (function () {for (i in 1:n) r <- attr(a,"b"); r })

sys.time(r<-f())
print(r)

test.name <- "tst-attr.set"

n <- 1000000

f <- test.cmp (function () {for (i in 1:n) { b <- a; attr(b,"bb") <- NULL }; b})

sys.time(r<-f())
print(r)

n <- 1000000

f <- test.cmp (function () {for (i in 1:n) { b <- a; attr(b,"bb") <- "x" }; b})

sys.time(r<-f())
print(r)

test.name <- "tst-attr.change"

L <- 1000
R <- 500
a <- 1:L

attr(a,"fred") <- rep("f",L)

f <- test.cmp (function (a) 
{ for (j in 1:R)
  { for (i in 1:L) attr(a,"fred")[i] <- "F"
  }
  a
})

sys.time(r<-f(a))
print(r)

names(a) <- rep("n",L)

f <- test.cmp (function (a) 
{ for (j in 1:R)
  { for (i in 1:L) names(a)[i] <- "N"
  }
  a
})

sys.time(r<-f(a))
print(r)
