source("time.r")
 

test.name <- "tst-lookup.local"

f <- test.cmp (function (rep) 
{ a <- 1; b <- 1; c <- 1; d <- 1; e <- 1; f <- 1; g <- 1; h <- 1; i <- 1;
  j <- 1; k <- 1; l <- 1; m <- 1; n <- 1; o <- 1; p <- 1; q <- 1; r <- 1;
  s <- 1; t <- 1; u <- 1; v <- 1; w <- 1; x <- 1; y <- 1; z <- 1;
  for (i in 1:rep) s <- s + a + b + c + x + y + z;
  s
})

sys.time(s <- f(2000000))
print(s)

g <- test.cmp (function (rep)
{ A <- 1; B <- 1; C <- 1; D <- 1; E <- 1; F <- 1; G <- 1; H <- 1; I <- 1;
  J <- 1; K <- 1; L <- 1; M <- 1; N <- 1; O <- 1; P <- 1; Q <- 1; R <- 1;
  S <- 1; T <- 1; U <- 1; V <- 1; W <- 1; X <- 1; Y <- 1; Z <- 1;
  f <- function ()
  { a <- 1; b <- 1; c <- 1; d <- 1; e <- 1; f <- 1; g <- 1; h <- 1; i <- 1;
    j <- 1; k <- 1; l <- 1; m <- 1; n <- 1; o <- 1; p <- 1; q <- 1; r <- 1;
    s <- 1; t <- 1; u <- 1; v <- 1; w <- 1; x <- 1; y <- 1; z <- 1;
    for (i in 1:rep) s <- s + A + B + C + X + Y + Z;
    s
  }
  f()
})

sys.time(s <- g(2000000))
print(s)
 

test.name <- "tst-lookup.global"

A <- 1; B <- 1; C <- 1; D <- 1; E <- 1; F <- 1; G <- 1; H <- 1; I <- 1;
J <- 1; K <- 1; L <- 1; M <- 1; N <- 1; O <- 1; P <- 1; Q <- 1; R <- 1;
S <- 1; T <- 1; U <- 1; V <- 1; W <- 1; X <- 1; Y <- 1; Z <- 1;

f <- test.cmp (function (rep) 
{ s <- 1;
  a <- 1; b <- 1; c <- 1; d <- 1; e <- 1; f <- 1; g <- 1; h <- 1; i <- 1;
  for (i in 1:rep) s <- s + A + B + C + X + Y + Z;
  s
})

sys.time(s <- f(2000000))
print(s)

A <- 1; B <- 1; C <- 1; D <- 1; E <- 1; F <- 1; G <- 1; H <- 1; I <- 1;
J <- 1; K <- 1; L <- 1; M <- 1; N <- 1; O <- 1; P <- 1; Q <- 1; R <- 1;
S <- 1; T <- 1; U <- 1; V <- 1; W <- 1; X <- 1; Y <- 1; Z <- 1;

f <- test.cmp (function (rep) 
{ a <- 1; b <- 1; c <- 1; d <- 1; e <- 1; f <- 1; g <- 1; h <- 1; i <- 1;
  j <- 1; k <- 1; l <- 1; m <- 1; n <- 1; o <- 1; p <- 1; q <- 1; r <- 1;
  s <- 1; t <- 1; u <- 1; v <- 1; w <- 1; x <- 1; y <- 1; z <- 1;
  for (i in 1:rep) s <- s + A + B + C + X + Y + Z;
  s
})

sys.time(s <- f(2000000))
print(s)

g <- test.cmp (function (rep)
{ A <- 1; B <- 1; C <- 1; D <- 1; E <- 1; F <- 1; G <- 1; H <- 1; I <- 1;
  J <- 1; K <- 1; L <- 1; M <- 1; N <- 1; O <- 1; P <- 1; Q <- 1; R <- 1;
  S <- 1; T <- 1; U <- 1; V <- 1; W <- 1; X <- 1; Y <- 1; Z <- 1;
  f <- function ()
  { a <- 1; b <- 1; c <- 1; d <- 1; e <- 1; f <- 1; g <- 1; h <- 1; i <- 1;
    j <- 1; k <- 1; l <- 1; m <- 1; n <- 1; o <- 1; p <- 1; q <- 1; r <- 1;
    s <- 1; t <- 1; u <- 1; v <- 1; w <- 1; x <- 1; y <- 1; z <- 1;
    for (i in 1:rep) s <- s + pi + pi*pi + pi*pi*pi
    s
  }
  f()
})

sys.time(s <- g(2000000))
print(s)


test.name <- "tst-lookup.function"

g <- test.cmp (function (rep)
{ A <- 1; B <- 1; C <- 1; D <- 1; E <- 1; F <- 1; G <- 1; H <- 1; I <- 1;
  J <- 1; K <- 1; L <- 1; M <- 1; N <- 1; O <- 1; P <- 1; Q <- 1; R <- 1;
  S <- 1; T <- 1; U <- 1; V <- 1; W <- 1; X <- 1; Y <- 1; Z <- 1;
  f <- function ()
  { a <- 1; b <- 1; c <- 1; d <- 1; e <- 1; f <- 1; g <- 1; h <- 1; i <- 1;
    j <- 1; k <- 1; l <- 1; m <- 1; n <- 1; o <- 1; p <- 1; q <- 1; r <- 1;
    s <- 1; t <- 1; u <- 1; v <- 1; w <- 1; x <- 1; y <- 1; z <- 1;
    for (i in 1:rep) s<-invisible(invisible(invisible(invisible(invisible(1)))))
    s
  }
  f()
})

sys.time(s <- g(2000000))
print(s)

g <- test.cmp (function (rep)
{ A <- 1; B <- 1; C <- 1; D <- 1; E <- 1; F <- 1; G <- 1; H <- 1; I <- 1;
  J <- 1; K <- 1; L <- 1; M <- 1; N <- 1; O <- 1; P <- 1; Q <- 1; R <- 1;
  S <- 1; T <- 1; U <- 1; V <- 1; W <- 1; X <- 1; Y <- 1; Z <- 1;
  f <- function ()
  { a <- 1; b <- 1; c <- 1; d <- 1; e <- 1; f <- 1; g <- 1; h <- 1; i <- 1;
    j <- 1; k <- 1; l <- 1; m <- 1; n <- 1; o <- 1; p <- 1; q <- 1; r <- 1;
    s <- 1; t <- 1; u <- 1; v <- 1; w <- 1; x <- 1; y <- 1; z <- 1;
    for (i in 1:rep) s <- - - - - - 1
    s
  }
  f()
})

sys.time(s <- g(2000000))
print(s)

g <- test.cmp (function (rep)
{ A <- 1; B <- 1; C <- 1; D <- 1; E <- 1; F <- 1; G <- 1; H <- 1; I <- 1;
  J <- 1; K <- 1; L <- 1; M <- 1; N <- 1; O <- 1; P <- 1; Q <- 1; R <- 1;
  S <- 1; T <- 1; U <- 1; V <- 1; W <- 1; X <- 1; Y <- 1; Z <- 1;
  `-` <- invisible
  f <- function ()
  { a <- 1; b <- 1; c <- 1; d <- 1; e <- 1; f <- 1; g <- 1; h <- 1; i <- 1;
    j <- 1; k <- 1; l <- 1; m <- 1; n <- 1; o <- 1; p <- 1; q <- 1; r <- 1;
    s <- 1; t <- 1; u <- 1; v <- 1; w <- 1; x <- 1; y <- 1; z <- 1;
    for (i in 1:rep) s <- - - - - - 1
    s
  }
  f()
})

sys.time(s <- g(2000000))
print(s)

g <- test.cmp (function (rep)
{ A <- 1; B <- 1; C <- 1; D <- 1; E <- 1; F <- 1; G <- 1; H <- 1; I <- 1;
  J <- 1; K <- 1; L <- 1; M <- 1; N <- 1; O <- 1; P <- 1; Q <- 1; R <- 1;
  S <- 1; T <- 1; U <- 1; V <- 1; W <- 1; X <- 1; Y <- 1; Z <- 1;
  f <- function ()
  { a <- 1; b <- 1; c <- 1; d <- 1; e <- 1; f <- 1; g <- 1; h <- 1; i <- 1;
    j <- 1; k <- 1; l <- 1; m <- 1; n <- 1; o <- 1; p <- 1; q <- 1; r <- 1;
    s <- 1; t <- 1; u <- 1; v <- 1; w <- 1; x <- 1; y <- 1; z <- 1;
    invisible <- `-`
    for (i in 1:rep) s<-invisible(invisible(invisible(invisible(invisible(1)))))
    s
  }
  f()
})

sys.time(s <- g(2000000))
print(s)

g <- test.cmp (function (rep)
{ A <- 1; B <- 1; C <- 1; D <- 1; E <- 1; F <- 1; G <- 1; H <- 1; I <- 1;
  J <- 1; K <- 1; L <- 1; M <- 1; N <- 1; O <- 1; P <- 1; Q <- 1; R <- 1;
  S <- 1; T <- 1; U <- 1; V <- 1; W <- 1; X <- 1; Y <- 1; Z <- 1;
  f <- function ()
  { a <- 1; b <- 1; c <- 1; d <- 1; e <- 1; f <- 1; g <- 1; h <- 1; i <- 1;
    j <- 1; k <- 1; l <- 1; m <- 1; n <- 1; o <- 1; p <- 1; q <- 1; r <- 1;
    s <- 1; t <- 1; u <- 1; v <- 1; w <- 1; x <- 1; y <- 1; z <- 1;
    invisible <- function () 0
    rm(invisible)
    for (i in 1:rep) s<-invisible(invisible(invisible(invisible(invisible(1)))))
    s
  }
  f()
})

sys.time(s <- g(2000000))
print(s)
