source("time.r")
 
test.name <- "tst-return.direct"

e1 <- test.cmp (function (a) 0)
e2 <- test.cmp (function (a) return (0))
e3 <- test.cmp (function (a) { if (a>2) 0 else 1 })
e4 <- test.cmp (function (a) { if (a>2) return (0) else return (1) })
e5 <- test.cmp (function (a) { if (a>2) return (0); return (1) })

f <- test.cmp (function () { for (i in 1:5000000) e1(1) }); sys.time(f())
f <- test.cmp (function () { for (i in 1:5000000) e2(1) }); sys.time(f())
f <- test.cmp (function () { for (i in 1:5000000) e3(1) }); sys.time(f())
f <- test.cmp (function () { for (i in 1:5000000) e3(3) }); sys.time(f())
f <- test.cmp (function () { for (i in 1:5000000) e4(1) }); sys.time(f())
f <- test.cmp (function () { for (i in 1:5000000) e4(3) }); sys.time(f())
f <- test.cmp (function () { for (i in 1:5000000) e5(1) }); sys.time(f())
f <- test.cmp (function () { for (i in 1:5000000) e5(3) }); sys.time(f())

test.name <- "tst-return.variant"

f <- test.cmp (function (a) { if (a>5) return (2:a); 2:5 })

a <- rep(1,100000)

g <- test.cmp (function () 
     { b <- 0; for (i in 1:2000) b <- b + sum(a[f(100000)]); b })
sys.time(b <- g())
print(b)
