source("time.r")

test.name <- "tst-serialize.serialize"

options(keep.source=FALSE)

fun <- parse (text='function (a,b,c,d) {  # fairly big nonsense function 
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a <- b+c+d; a[1] <- b[1]+c[1]+d[1]; d <- sqrt(a+b); for (i in 1:100) a <- a+1
 a
}')

lis <- rep ( list (a=1:1000, b=1:1000+0.1, c=rep(c(T,F),500), 
                   d=rep("ab",1000), e = (1:500)+(1001:1500)*0.25i), 10)

f <- test.cmp(function (w,n,x,a) 
       { for (i in 1:n) r <- serialize(w,NULL,ascii=a,xdr=x); r })

sys.time(r1 <- f(fun,10000,TRUE,FALSE))
print(length(r1))

sys.time(r2 <- f(lis,1000,TRUE,FALSE))
print(length(r2))

sys.time(r3 <- f(fun,10000,FALSE,FALSE))
print(length(r3))

sys.time(r4 <- f(lis,1000,FALSE,FALSE))
print(length(r4))

sys.time(r5 <- f(fun,1000,FALSE,TRUE))
print(length(r5))

sys.time(r6 <- f(lis,100,FALSE,TRUE))
print(length(r6))

test.name <- "tst-serialize.unserialize"

g <- test.cmp(function(w,n)
       { for (i in 1:n) o <- unserialize(w); o })

sys.time(o <- g(r1,10000))
print(identical(o,fun))

sys.time(o <- g(r2,1000))
print(identical(o,lis))

sys.time(o <- g(r3,10000))
print(identical(o,fun))

sys.time(o <- g(r4,1000))
print(identical(o,lis))

sys.time(o <- g(r5,1000))
print(identical(o,fun))

sys.time(o <- g(r6,100))
print(identical(o,lis))
