source("time.r")

a <- 1:1000
b <- 1001:2000
s <- 2:5
n <- 1000000

test.name <- "tst-vec-arith.int.+"
f <- test.cmp (function () { for (i in 1:n) r <- wait(1+a); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a+1); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a+b); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a+s); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(s+a); r})
sys.time(r <- f()); print(sum(r))
 
a <- seq(1,2,length=1000)
b <- seq(3,4,length=1000)
s <- seq(5,6,length=4)
n <- 500000

test.name <- "tst-vec-arith.real.+"
f <- test.cmp (function () { for (i in 1:n) r <- wait(1+a); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a+1); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a+b); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a+s); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(s+a); r})
sys.time(r <- f()); print(sum(r))

test.name <- "tst-vec-arith.real.-"
f <- test.cmp (function () { for (i in 1:n) r <- wait(1-a); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a-1); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a-b); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a-s); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(s-a); r})
sys.time(r <- f()); print(sum(r))

test.name <- "tst-vec-arith.real.*"
f <- test.cmp (function () { for (i in 1:n) r <- wait(3*a); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a*3); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a*b); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a*s); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(s*a); r})
sys.time(r <- f()); print(sum(r))

test.name <- "tst-vec-arith.real./"
f <- test.cmp (function () { for (i in 1:n) r <- wait(3/a); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a/3); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a/b); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a/s); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(s/a); r})
sys.time(r <- f()); print(sum(r))

test.name <- "tst-vec-arith.real.%%-%/%"

a <- (1:1000) + 0.0
b <- (2:1001) + 0.0
n <- 200000

f <- test.cmp (function () { for (i in 1:n) r <- wait(a%%3); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a%/%3); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a%%3.1); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a%/%3.1); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a%%b); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a%/%b); r})
sys.time(r <- f()); print(sum(r))
 
a <- seq(1,2,length=1000) + 1i
b <- seq(3,4,length=1000) + 2i
s <- seq(5,6,length=4)
n <- 500000

test.name <- "tst-vec-arith.complex.+"
f <- test.cmp (function () { for (i in 1:n) r <- wait(1+a); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a+1); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a+b); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a+s); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(s+a); r})
sys.time(r <- f()); print(sum(r))

test.name <- "tst-vec-arith.complex.-"
f <- test.cmp (function () { for (i in 1:n) r <- wait(1-a); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a-1); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a-b); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a-s); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(s-a); r})
sys.time(r <- f()); print(sum(r))

test.name <- "tst-vec-arith.complex.*"
f <- test.cmp (function () { for (i in 1:n) r <- wait(3*a); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a*3); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a*b); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a*s); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(s*a); r})
sys.time(r <- f()); print(sum(r))

test.name <- "tst-vec-arith.complex./"
f <- test.cmp (function () { for (i in 1:n) r <- wait(3/a); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a/3); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a/b); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(a/s); r})
sys.time(r <- f()); print(sum(r))
f <- test.cmp (function () { for (i in 1:n) r <- wait(s/a); r})
sys.time(r <- f()); print(sum(r))
